' =======================================================================================================================
' = Profan-CGI-Interface                                                                                                =
' = (C) Copyright 2003..04 by Steffen Lange, Alle Rechte vorbehalten.                                                   =
' = PROFCGI.INC                                                                                                         =
' =======================================================================================================================
' = Version fr: Win32                                                                      = letzter Stand: 27.02.2004 =
' =======================================================================================================================
Declare CGI_PROFAN_PROGRAM$, CGI_PROFAN_VERSION$, CGI_PROFAN_COPYRIGHT$, CGI_PROFAN_WEBSITE$
Let CGI_PROFAN_PROGRAM$="PROFan-CGI-inTERFAcE"
Let CGI_PROFAN_VERSION$="Version 0.3.4 (Build 20)"
Let CGI_PROFAN_COPYRIGHT$="(C) Copyright 2003..04 by Steffen Lange"
Let CGI_PROFAN_WEBSITE$="http://www.stelas.de/"
' =======================================================================================================================
' = Lauffhig unter: Profan 7.x (Win32) und Profan-Console (Linux; eingeschrnkte Funktionalitt!)                    =
' =======================================================================================================================
' = Diese Include-Datei stellt lediglich eine Schnittstellen-Vorlage fr Profan-Programmierer da, die damit CGI-        =
' = Anwendungen entwickeln wollen und erhebt somit keinen Anspruch auf Vollstndigkeit und Fehlerfreiheit.              =
' = Alle Rechte an diesem Quellcode liegen bei Steffen Lange, Rathenow. Dieser Quellcode darf nur in unvernderter Form =
' = weitergegeben werden. Insbesondere drfen die Copyright-Hinweise nicht entfernt werden.                             =
' = Fehlerbereinigte bzw. erweiterte Versionen schicken Sie bitte an die eMail-Adresse stelas@steffen-lange.com, damit  =
' = Ihre Verbesserungen in die offizielle Version eingepflegt werden knnen und allen Profan-Usern zur Verfgung stehen.=
' = Anwendungen, die auf diesem Quellcode basieren, mssen einen Hinweis (z.B. im Footer von den generierten HTML-      =
' = Seiten) anzeigen.                                                                                                   =
' =======================================================================================================================
' = Was fehlt noch? Die Post-Methode wird nur mit dem Content-Type application/x-www-form-urlencoded untersttzt.     =
' =======================================================================================================================
' = Einschrnkungen:                                                                                                    =
' = * bergebene Werte (stdin, stdout, URL) werden in langen Profan-Strings gespeichert (nur unter Win32 ab Version 7)  =
' = * Lesen von stdin funktiniert nur unter Win32 mittels API-Aufrufen                                                  =
' = * Schreiben auf stdout funktioniert unter Linux mittels Print-Befehl nur limitiert (wegen Zeilenumbrchen, etc.)    =
' =======================================================================================================================

' -----------------------
' CGI-Umgebungs-Variablen
' -----------------------
Declare CGI_SERVER_SOFTWARE$, CGI_SERVER_NAME$, CGI_GATEWAY_INTERFACE$
Declare CGI_SERVER_PROTOCOL$, CGI_SERVER_PORT$, CGI_REQUEST_METHOD$, CGI_PATH_INFO$, CGI_PATH_TRANSLATED$, CGI_SCRIPT_NAME$
Declare CGI_QUERY_STRING$, CGI_REMOTE_HOST$, CGI_REMOTE_ADDR$, CGI_AUTH_TYPE$, CGI_REMOTE_USER$, CGI_REMOTE_IDENT$
Declare CGI_CONTENT_TYPE$, CGI_CONTENT_LENGTH$
Declare CGI_HTTP_ACCEPT$, CGI_HTTP_USER_AGENT$
Let CGI_SERVER_SOFTWARE$=@GetEnv$("SERVER_SOFTWARE")
Let CGI_SERVER_NAME$=@GetEnv$("SERVER_NAME")
Let CGI_GATEWAY_INTERFACE$=@GetEnv$("GATEWAY_INTERFACE")
Let CGI_SERVER_PROTOCOL$=@GetEnv$("SERVER_PROTOCOL")
Let CGI_SERVER_PORT$=@GetEnv$("SERVER_PORT")
Let CGI_REQUEST_METHOD$=@GetEnv$("REQUEST_METHOD")
Let CGI_PATH_INFO$=@GetEnv$("PATH_INFO")
Let CGI_PATH_TRANSLATED$=@GetEnv$("PATH_TRANSLATED")
Let CGI_SCRIPT_NAME$=@GetEnv$("SCRIPT_NAME")
Let CGI_QUERY_STRING$=@GetEnv$("QUERY_STRING")
Let CGI_REMOTE_HOST$=@GetEnv$("REMOTE_HOST")
Let CGI_REMOTE_ADDR$=@GetEnv$("REMOTE_ADDR")
Let CGI_AUTH_TYPE$=@GetEnv$("AUTH_TYPE")
Let CGI_REMOTE_USER$=@GetEnv$("REMOTE_USER")
Let CGI_REMOTE_IDENT$=@GetEnv$("REMOTE_IDENT")
Let CGI_CONTENT_TYPE$=@GetEnv$("CONTENT_TYPE")
Let CGI_CONTENT_LENGTH$=@GetEnv$("CONTENT_LENGTH")
Let CGI_HTTP_ACCEPT$=@GetEnv$("HTTP_ACCEPT")
Let CGI_HTTP_USER_AGENT$=@GetEnv$("HTTP_USER_AGENT")

' -----------------------
' Win32-API-Deklarationen
' -----------------------
If @Equ(%Win32,1)
  Def @CGIGetStdHandle(1) !"KERNEL32.DLL","GetStdHandle"
  Def @CGIReadFile(5) !"KERNEL32.DLL","ReadFile"
  Def @CGIWriteFile(5) !"KERNEL32.DLL","WriteFile"
  Def @CGIOemToCharBuff(3) !"USER32.DLL","OemToCharBuffA"
  Def @CGICharToOemBuff(3) !"USER32.DLL","CharToOemBuffA"
  Declare CGI_text#, CGI_len#
EndIf

' ---------------
' CGIWrite String
' ---------------
' 1. Parameter: String - auszugebender Text
' Ausgabe einer Zeichenkette auf Std.-Out
' ---------------
Proc CGIWrite
Parameters text$
  If @Or(@Equ(CGI_GET%,1),@Equ(CGI_POST%,1))
    If @Equ(%Win32,1)
      Declare stdouthandle&
      Dim CGI_text#,@Len(text$)
      Dim CGI_len#,4
      String CGI_text#,0=text$
      Let stdouthandle&=@CGIGetStdHandle(-11)
      '@CGICharToOemBuff(CGI_text#,CGI_text#,@Len(text$))
      @CGIWriteFile(stdouthandle&,CGI_text#,@Len(text$),CGI_len#,0)
      Dispose CGI_text#
      Dispose CGI_len#
    ElseIf @Equ(%LINUX,1)
      Print text$;
    EndIf
  EndIf
EndProc

' -----------------
' CGIWriteLn String
' -----------------
' 1. Parameter: String - auszugebender Text
' Ausgabe einer Zeichenkette auf Std.-Out
' mit abschliessendem <CR><LF>
' -----------------
Proc CGIWriteLn
Parameters text$
  If @Or(@Equ(CGI_GET%,1),@Equ(CGI_POST%,1))
    If @Equ(%Win32,1)
      Let text$=@Add$(text$,@Add$(@Chr$(13),@Chr$(10)))
      CGIWrite text$
    ElseIf @Equ(%LINUX,1)
      Print text$
    EndIf
  EndIf
EndProc

' -----------------
' String <= CGIRead
' -----------------
' Rckgabe: String - gelesener Text
' Einlesen der Zeichenkette auf Std.-In
' -----------------
Declare CGI_READ%
Proc CGIRead
  Declare text$
  Let text$=""
  If @And(@And(@And(@Equ(CGI_POST%,1),@Equ(CGI_READ%,0)),@Gt(CGI_INLEN%,0)),@Equ(%Win32,1))
    Declare stdinhandle&, len&
    Let CGI_READ%=1
    Dim cgi_text#,CGI_INLEN%
    Dim cgi_len#,4
    Let stdinhandle&=@CGIGetStdHandle(-10)
    @CGIReadFile(stdinhandle&,cgi_text#,CGI_INLEN%,cgi_len#,0)
    Let CGI_INLEN%=@Long(cgi_len#,0)
    @CGIOemToCharBuff(cgi_text#,cgi_text#,@Long(cgi_len#,0))
    Let text$=@String$(cgi_text#,0)
    Dispose cgi_text#
    Dispose cgi_len#
  EndIf
  Return text$
EndProc

' ------------------
' Integer <= CGIInit
' ------------------
' Rckgabe: Integer - 1 bei Erfolg, -1 bei Fehler
' Durchfhrung der Initialisierung
' ------------------
Declare CGI_INIT%
Declare CGI_GET%, CGI_HEAD%, CGI_POST%, CGI_PUT%
Declare CGI_IN$, CGI_INLEN%, CGI_INTYP$
Proc CGIInit
  If @Equ(CGI_INIT%,0)
    Let CGI_INIT%=-1
    If @Or(@Equ(%Win32,1),@Equ(%LINUX,1))
      If @Equ$(CGI_REQUEST_METHOD$,"GET")
        Let CGI_INIT%=1
        Let CGI_GET%=1
        Let CGI_INLEN%=@Len(CGI_QUERY_STRING$)
        Let CGI_IN$=CGI_QUERY_STRING$
      ElseIf @Equ$(CGI_REQUEST_METHOD$,"HEAD")
        Let CGI_INIT%=1
        Let CGI_HEAD%=1
        Let CGI_INLEN%=@Len(CGI_QUERY_STRING$)
        Let CGI_IN$=CGI_QUERY_STRING$
      ElseIf @Equ$(CGI_REQUEST_METHOD$,"POST")
        Let CGI_INIT%=1
        Let CGI_POST%=1
        Let CGI_INTYP$=CGI_CONTENT_TYPE$
        If @Equ$(CGI_CONTENT_TYPE$,"application/x-www-form-urlencoded")
          Let CGI_INLEN%=@Val(CGI_CONTENT_LENGTH$)
          CGIRead
          Let CGI_IN$=@$(0)
        EndIf
      ElseIf @Equ$(CGI_REQUEST_METHOD$,"PUT")
        Let CGI_INIT%=1
        Let CGI_PUT%=1 ' Put-Methode wird jedoch nicht untersttzt!
      EndIf
    EndIf
  EndIf
  Return CGI_INIT%
EndProc

' ---------------------------
' CGISetHeaderLocation String
' ---------------------------
' 1. Parameter: String - URL
' Umleitung zur angegebenen URL
' ---------------------------
Proc CGISetHeaderLocation
Parameters url$
  If @Or(@Equ(CGI_GET%,1),@Or(@Equ(CGI_HEAD%,1),@Equ(CGI_POST%,1)))
    CGIWriteLn @Add$("Location: ",url$)
    CGIWriteLn ""
  EndIf
EndProc

' ---------------------------------
' CGISetHeaderStatus Integer String
' ---------------------------------
' 1. Parameter: Integer - HTTP-Statuscode nnn
' 2. Parameter: String - Text zum Statuscode
' Ausgabe einer HTTP-Statusmeldung
' ---------------------------------
Proc CGISetHeaderStatus
Parameters no%, text$
  If @Or(@Equ(CGI_GET%,1),@Or(@Equ(CGI_HEAD%,1),@Equ(CGI_POST%,1)))
    CGIWriteLn @Add$("Status: ",@Add$(@Str$(no%),@Add$(" ",@Add$(@Chr$(34),@Add$(text$,@Chr$(34))))))
    CGIWriteLn ""
  EndIf
EndProc

' -----------------------
' CGISetHeaderMIME String
' -----------------------
' 1. Parameter: String - MIME-Header
' Angabe des zurckzugebenden MIME-Headers
' -----------------------
Proc CGISetHeaderMIME
Parameters mime$
  If @Or(@Equ(CGI_GET%,1),@Or(@Equ(CGI_HEAD%,1),@Equ(CGI_POST%,1)))
    CGIWriteLn @Add$("Content-type: ",mime$)
    CGIWriteLn ""
  EndIf
EndProc

' --------------------------------------
' Integer <= CGICountChars String String
' --------------------------------------
' 1. Parameter: String - Zeichenkette
' 2. Parameter: String - Zhl-Zeichen
' Rckgabe    : Integer - Anzahl der gezhlten Zeichen
' Ermittlung der Anzahl des Vorkommens des Zhl-Zeichens
' in der zu durchsuchenden Zeichenkette
' --------------------------------------
Proc CGICountChars
Parameters string$, char$
  Declare count%
  Let count%=@Sub(@Len(string$),@Len(@Translate$(string$,@Mid$(char$,1,1),"")))
  Return count%
EndProc

' --------------------------------
' String <= CGIDecodeString String
' --------------------------------
' 1. Parameter: String - Zeichenkette mit Escape-Sequenzen
' Rckgabe    : String - Zeichenkette in lesbarer Form
' Umwandlung eines Strings mit Escape-Sequenzen in einen
' String mit den entsprechenden "lesbaren" Sonderzeichen
' --------------------------------
Proc CGIDecodeString
Parameters string$
  Declare zeichen$, laenge%, lauf%, code$
  Let lauf%=0
  Let laenge%=@Len(string$)
  While @Lt(lauf%,laenge%)
    Inc lauf%
    Let laenge%=@Len(string$)
    Let zeichen$=@Mid$(string$,lauf%,1)
    If @And(@Equ$(zeichen$,"%"),@Lt(@Add(lauf%,1),laenge%))
      Let code$=@Add$("$",@Upper$(@Mid$(string$,@Add(lauf%,1),2)))
      If @And(@Gt(@InStr(@Mid$(code$,2,1),"0123456789ABCDEF"),0),@Gt(@InStr(@Mid$(code$,3,1),"0123456789ABCDEF"),0))
        Let code$=@Chr$(@Val(code$))
        Let string$=@Del$(string$,lauf%,3)
        Let string$=@Ins$(code$,string$,lauf%)
      EndIf
    ElseIf @Equ$(zeichen$,"+")
      Let string$=@Del$(string$,lauf%,1)
      Let string$=@Ins$(" ",string$,lauf%)
    EndIf
  Wend
  Return string$
EndProc

' -----------------------------------------------
' String <= CGIPartOfString String String Integer
' -----------------------------------------------
' 1. Parameter: String - kompletter String
' 2. Parameter: String - Trenn-Zeichen
' 3. Parameter: Integer - Teilnummer 1..n
' Rckgabe    : String - Teil-String
' Ermittlung des n-ten Teils eines zusammengesetzten Strings,
' der Form "...t...t...t..." mit dem Trenn-Zeichen "t"
' -----------------------------------------------
Proc CGIPartOfString
Parameters string$, divid$, no%
  Declare lauf%, pos%, teil$
  Let divid$=@Mid$(divid$,1,1)
  Let string$=@Add$(string$,divid$)
  Let teil$=""
  Let lauf%=0
  While @Lt(lauf%,no%)
    Inc lauf%
    Let pos%=@InStr(divid$,string$)
    If @Equ(pos%,0)
      Let pos%=@Len(string$)
    EndIf
    Let teil$=@Mid$(string$,1,@Sub(pos%,1))
    Let string$=@Del$(string$,1,pos%)
  Wend
  Return teil$
EndProc

' -------------------------
' Integer <= CGIGetVarCount
' -------------------------
' Rckgabe: Integer - Parameteranzahl >=0
' Anzahl der bei der HTTP-Anfrage bergebenen Parameter
' -------------------------
Proc CGIGetVarCount
  Declare count%
  Let count%=0
  If @And(@Or(@Or(@Equ(CGI_GET%,1),@Equ(CGI_HEAD%,1)),@And(@Equ(CGI_POST%,1),@Equ$(CGI_INTYP$,"application/x-www-form-urlencoded"))),@Gt(CGI_INLEN%,0))
    CGICountChars CGI_IN$,"&"
    Let count%=@Add(@%(0),1)
  EndIf
  Return count%
EndProc

' -------------------------------
' String <= CGIGetVarName Integer
' -------------------------------
' 1. Parameter: Integer - Parameternummer 1..n
' Rckgabe    : String - Name des Parameters
' Name des angegebenen Parameters
' -------------------------------
Proc CGIGetVarName
Parameters no%
  Declare name$
  Let name$=""
  CGIGetVarCount
  If @And(@Gt(no%,0),@Lt(no%,@Add(@%(0),1)))
    CGIPartOfString CGI_IN$,"&",no%
    CGIPartOfString @$(0),"=",1
    Let name$=@$(0)
  EndIf
  Return name$
EndProc

' --------------------------------
' String <= CGIGetVarValue Integer
' --------------------------------
' 1. Parameter: Integer - Parameternummer 1..n
' Rckgabe    : String - Wert des Parameters
' Wert des angegebenen Parameters
' --------------------------------
Proc CGIGetVarValue
Parameters no%
  Declare value$
  Let value$=""
  CGIGetVarCount
  If @And(@Gt(no%,0),@Lt(no%,@Add(@%(0),1)))
    CGIPartOfString CGI_IN$,"&",no%
    CGIPartOfString @$(0),"=",2
    CGIDecodeString @$(0)
    Let value$=@$(0)
  EndIf
  Return value$
EndProc

' =======================================================================================================================
' = Beispiel-Routinen (fr Testzwecke) ==================================================================================
' =======================================================================================================================

' -----------------
' CGIWriteHTMLAbout
' -----------------
' HTML-konforme Ausgabe des Copyright-Hinweises
' -----------------
Proc CGIWriteHTMLAbout
  CGIWriteLn CGI_PROFAN_PROGRAM$
  CGIWriteLn CGI_PROFAN_VERSION$
  CGIWriteLn CGI_PROFAN_COPYRIGHT$
EndProc

' -------------------
' CGIWriteHTMLEnvVars
' -------------------
' HTML-konforme Ausgabe der CGI-Umgebungsvariablen
' -------------------
Proc CGIWriteHTMLEnvVars
  CGIWriteLn "<table><tr><td>SERVER_SOFTWARE</td><td>=</td><td>"
  CGIWriteLn CGI_SERVER_SOFTWARE$
  CGIWriteLn "</td></tr><tr><td>SERVER_NAME</td><td>=</td><td>"
  CGIWriteLn CGI_SERVER_NAME$
  CGIWriteLn "</td></tr><tr><td>GATEWAY_INTERFACE</td><td>=</td><td>"
  CGIWriteLn CGI_GATEWAY_INTERFACE$
  CGIWriteLn "</td></tr><tr><td>SERVER_PROTOCOL</td><td>=</td><td>"
  CGIWriteLn CGI_SERVER_PROTOCOL$
  CGIWriteLn "</td></tr><tr><td>SERVER_PORT</td><td>=</td><td>"
  CGIWriteLn CGI_SERVER_PORT$
  CGIWriteLn "</td></tr><tr><td>REQUEST_METHOD</td><td>=</td><td>"
  CGIWriteLn CGI_REQUEST_METHOD$
  CGIWriteLn "</td></tr><tr><td>PATH_INFO</td><td>=</td><td>"
  CGIWriteLn CGI_PATH_INFO$
  CGIWriteLn "</td></tr><tr><td>PATH_TRANSLATED</td><td>=</td><td>"
  CGIWriteLn CGI_PATH_TRANSLATED$
  CGIWriteLn "</td></tr><tr><td>SCRIPT_NAME</td><td>=</td><td>"
  CGIWriteLn CGI_SCRIPT_NAME$
  CGIWriteLn "</td></tr><tr><td>QUERY_STRING</td><td>=</td><td>"
  CGIWriteLn CGI_QUERY_STRING$
  CGIWriteLn "</td></tr><tr><td>REMOTE_HOST</td><td>=</td><td>"
  CGIWriteLn CGI_REMOTE_HOST$
  CGIWriteLn "</td></tr><tr><td>REMOTE_ADDR</td><td>=</td><td>"
  CGIWriteLn CGI_REMOTE_ADDR$
  CGIWriteLn "</td></tr><tr><td>AUTH_TYPE</td><td>=</td><td>"
  CGIWriteLn CGI_AUTH_TYPE$
  CGIWriteLn "</td></tr><tr><td>REMOTE_USER</td><td>=</td><td>"
  CGIWriteLn CGI_REMOTE_USER$
  CGIWriteLn "</td></tr><tr><td>REMOTE_IDENT</td><td>=</td><td>"
  CGIWriteLn CGI_REMOTE_IDENT$
  CGIWriteLn "</td></tr><tr><td>CONTENT_TYPE</td><td>=</td><td>"
  CGIWriteLn CGI_CONTENT_TYPE$
  CGIWriteLn "</td></tr><tr><td>CONTENT_LENGTH</td><td>=</td><td>"
  CGIWriteLn CGI_CONTENT_LENGTH$
  CGIWriteLn "</td></tr><tr><td>HTTP_ACCEPT</td><td>=</td><td>"
  CGIWriteLn CGI_HTTP_ACCEPT$
  CGIWriteLn "</td></tr><tr><td>HTTP_USER_AGENT</td><td>=</td><td>"
  CGIWriteLn CGI_HTTP_USER_AGENT$
  CGIWriteLn "</td></tr></table>"
EndProc
